/*-----------------------------------------------------*/
/*--	Micro-EMPIX CORE  (Micro.c)                   -*/
/*--    Ver 1.0 (c) 2004                              -*/
/*--	E             -*/
/*--    ==================================            -*/
/*--    .                  -*/
/*--    .                        -*/
/*--    . .                      -*/
/*-----------------------------------------------------*/

#ifndef _DEFS_H
	#define _DEFS_H
	#include "defs.h"
#endif

#ifndef _ASM_H
	#define _ASM_H
	#include "asm.h"
#endif

#ifndef _CLOCK_H
	#define _CLOCK_H
	#include "clock.h"
#endif

#ifndef _SEM_H
	#define _SEM_H
	#include "sem.h"
#endif

#ifndef _PROC_H
	#define _PROC_H
	#include "proc.h"
#endif

#ifndef _DISPLOW_H_
	#define _DISPLOW_H_
	#include "displow.h"
#endif

#ifndef _DISPHIGH_H_
	#define _DISPHIGH_H_
	#include "disphigh.h"
#endif

#ifndef _KEYBLOW_H_
	#define _KEYBLOW_H_
	#include "keyblow.h"
#endif

#ifndef _UARTLOW_H
	#define _UARTLOW_H
	#include "UARTLow.h"
#endif

#ifndef _UARTHIGH_H
	#define _UARTHIGH_H
	#include "UARTHigh.h"
#endif

#include "sema.h"


/*=========================================================================================*/
/*    null process.        */
/*   .. */

void Idle(void) {
 while(1) ;
}

/*=========================================================================================*/
/*        ..   */
/*   */

void Initialize (void) {
	int i,j;
	for (i=0;i<MAXSEM;i++)				/* A   */
		for (j=0;j<MAXPROC;j++) {
			semaphores[i][j]=0;
			semavalue[i]=0;
		}
	bSetColor(SCR_White, SCR_Black, 0); /*     */
	numproc=0;							/*     . = 0 */
	current=-1;							/*      */
}



void main(void)
{
	int ps;
	disabl_intr(&ps);
	Initialize(); /*    .. */
    create(Idle,0,"Idle",0); /*  null process */

	/*======================================================================*/
	/*==================    ======================*/
	/*======================================================================*/
	Initializer();

	create (P1,0,"Reader",1);
	create (P2,0,"Writer",1);
	/*      */


	/*======================================================================*/
	/*======================================================================*/

	clkinit(); /*       */
	restor_intr (&ps);
	bPrintStr("Processes Created");

	enable_all_intr();
	while (1);
}
/*=========================================================================================*/
